;
;  speed2.asm
;  C. Ward 2/7/93
;
;  Runs through a  longer loop a few times to run a
;  performance test on the simulation.  Currently (Sparc
;  station 1+) it takes 14 seconds to run.
;
;
    org $1000
    clr.l d1
    clr.l d2
    clr.l d3
    movea.l d1,a1
    movea.l d2,a2
    movea.l d3,a3
    movea.l #p1msg,a5
    movea.l #p2msg,a6
    move.w #227,d7
    trap #14
    move.l #$1000,d4

p1  tst d4
    beq p2
    add d1,d2
    jsr chk
    move.l #1,d1
    asl #4,d1
    asr #4,d1
    cmp #1,d1
    bne err
    subq #1,d4
    bra p1

p2  movea.l #p3msg,a6
    move #227,d7
    trap #14
    move.l #$500,d4
p2a tst.l d4
    beq p3
    subq #1,d4
    move.l #20,d1
    move.l #0,d2
    mulu d2,d1
    tst d1
    bne err
    nop
    movea.l #1200,a2
    clr.b (a2)
    not.b (a2)
    not.b (a2)
    tst.b (a2)
    bne err
    bra p2a

p3  movea.l #dmsg,a6
    move.b #227,d7
    trap #14
    move.l #228,d7
    trap #14

err move #228,d7
    trap #14


chk cmp d1,d2
    bne don
    beq don
don rts


p1msg dc.b 'We are in part 1....'
p2msg dc.b 'We are in part 2....'
p3msg dc.b 'We are in part 3....bye now!'
dmsg  dc.b 0
    end


